//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include <g_palette.h>

#define GAME_LOAD_ADDRESS (void*)0x4000
#define GAME_RUN_ADDRESS  (void*)0x659E
#define PRESS_SPACE_ADDRESS (void*)0x4CF4
#define GAME_BIN_SIZE     17841
void load_screen()
{
  //cpct_setVideoMode(0);
  cpct_setVideoMode(1);

  //cpct_setPalette(g_palette, 16);
  cpct_setPalette(g_palette, 4);

  cpct_miniload((void*)0xC000, 0x4000);

  cpct_setBorder (0);
}

void main(void)
{
  // Define a functions pointer that will be used to point and call to our
  // game's main() function code.
  void (*press_space)() = PRESS_SPACE_ADDRESS;
  void (*game_main)() = GAME_RUN_ADDRESS;

  cpct_disableFirmware();

  // Load load screen
  load_screen ();

  // Load main game
  if (!cpct_miniload (GAME_LOAD_ADDRESS, GAME_BIN_SIZE) ) {
    cpct_setBorder (HW_BLACK);
    press_space();
    game_main();
  }
}
