//-----------------------------LICENSE NOTICE--------------------------------
//  This file is part of CPCRogue: An Amstrad CPC rogue like game
//  Copyright (C) 2019 Andrés Mata Bretón (@FlautinesMata)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
#include <cpctelera.h>
#include <stdbool.h>
#include <stdio.h>
#include "consts.h"
#include "stairs.h"
#include "game.h"

struct TStairs stairs_list[MAX_STAIRS];
u8 num_stairs;
struct TStairs *plast_stairs;

//---------------------------------------------------------------------------
void init_stairs() {
  cpct_memset (stairs_list, 0x0, sizeof (stairs_list));
  num_stairs = 0;
  plast_stairs = stairs_list;
}

//---------------------------------------------------------------------------
struct TStairs *stairs_create (bool downwards)
{
  struct TStairs *stairs = NULL;

  if (num_stairs < MAX_STAIRS)
  {

    // Get an empty slot from the ai array
    stairs = plast_stairs++;
    num_stairs++;
    stairs->downwards = downwards;
  }

  return stairs;
}
//---------------------------------------------------------------------------
void use_stairs (struct TStairs *stairs)
{
  if (stairs->downwards)
    transition_next();
  else
    transition_previous();

}