//-----------------------------LICENSE NOTICE--------------------------------
//  This file is part of CPCRogue: An Amstrad CPC rogue like game
//  Copyright (C) 2019 Andrés Mata Bretón (@FlautinesMata)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
typedef struct {
  char *text;
  u8    x;
  u8    y;
  u8    fg_color;
  u8    bg_color;
} TTextLine;

inline void cls()
{
  cpct_clearScreen_f64 (0x0000);
}

/*! \brief
 * Clears a portion of the specified display buffer */
void clrwin (u8 *pvmem_start, u8 cols, u8 rows, u8 color);
/*! \brief
 * Clears the log area */
void clr_log();
void clr_stats();
void clr_map();
/*! \brief
 * Draws a character to the specified position in a screen buffer.*/
void putchar_f (void *pvmem_start, u8 x, u8 y, u8 ch, u8 fg_pen, u8 bg_pen);
//void log_msg (char *msg);
void log_msg_ext (char *text);
void press_any_key_cont();
void wait_for_key(cpct_keyID key) ;
///< Get string from stdin
char *get_string (char *str, u8 x, u8 y, u8 fg_color, u8 bg_color);
///< Display lines of text from a TTextLine array
void display_text_lines (TTextLine pline[], u8 nlines);
///< Get center offset in bytes of a string
u8 get_center (u8 startx, u8 width, char *str);

void fw_set_palette (u8 acolors[]);
void fw_set_border  (u8 bgcolor);