//-----------------------------LICENSE NOTICE--------------------------------
//  This file is part of CPCRogue: An Amstrad CPC rogue like game
//  Copyright (C) 2019 Andrés Mata Bretón (@FlautinesMata)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
#include <cpctelera.h>
#include <stdbool.h>
#include "consts.h"
#include "conio.h"
#include "orutrix.h"


const u8          happy_ending_palette[4] = {
  BLACK, PASTEL_YELLOW, BRIGHT_WHITE, BRIGHT_CYAN
};

const TTextLine ending[] = {
  // Text, x,y, fg_color, bg_color
  {"Without thinking about it your fingers",          1,1,  3,0 },
  {"start to tap the Orutrix in a special",           1,2,  3,0 },
  {"pattern, it's like someone (or",                  1,3,  3,0 },
  {"something) is guiding your actions.",             1,4,  3,0 },
  {"Suddenly, your eyes feel heavy and",              1,5,  3,0 },
  {"everything fades to black.",                      1,6,  3,0 },
  {"When you wake up you need to cover your",         1,8,  3,0 },
  {"eyes from the overwhelming burst of",             1,9,  3,0 },
  {"light that's coming from the Sun. But",           1,10, 3,0 },
  {"you welcome that intense light because",          1,11, 3,0 },
  {"it means you are out of the dungeon.",            1,12, 3,0 },
  {"Congratulations!",                                7,15, 1,0 },
};

//---------------------------------------------------------------------------
void use_orutrix (struct TEntity *target, u8 value)
{
  extern bool game_running;
  extern bool orutrix_found;
  extern u8   num_messages;

  clr_log();
  log_msg_ext ("\477\11\12You use the ORUTRIX");

  // Press [SPACE]
  cpct_drawStringM1_f ("Press [SPACE] to continue",
  (void*)(VMEM_LOG+num_messages*0x50),
  REVERSE_FG, REVERSE_BG);

  wait_for_key (Key_Space);

  // Finish game (happy ending)
  game_running  = false;
  orutrix_found = true;
}

//---------------------------------------------------------------------------
void happy_ending()
{
  cpct_setPalette (happy_ending_palette, 4);
  cls();
  display_text_lines (ending, NUM_ENDING_LINES);
}