//-----------------------------LICENSE NOTICE--------------------------------
//  This file is part of CPCRogue: An Amstrad CPC rogue like game
//  Copyright (C) 2019 Andrés Mata Bretón (@FlautinesMata)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
#include <cpctelera.h>
#include <string.h>
#include <stdbool.h>
#include "consts.h"
#include "conio.h"
#include "permadeath.h"
#include "entity.h"

const u8 perma_palette[4] = {
  0x54, 0x56, 0x40, 0x5C
};
const TTextLine permadeath[] = {
  // Text, x,y, fg_color, bg_color
  {"\xd6\x8f\x8f\x8f\x8f\x8f\x8f\xd7", 15,2, 2,0},                // 1
  {"\x8f\x8f\x8f\x81\x82\x8f\x8f\x8f", 15,3, 2,0},                // 2
  {"\x8f\x8f\x8f\x84\x88\x8f\x8f\x8f", 15,4, 2,0},                // 3
  {"\x8f\x8f\x8f\x85\x8a\x8f\x8f\x8f", 15,5, 2,0},                // 4
  {"\xd6\x8f\x8f\x8f\x8f\x8f\x8f\x8f\x8f\xd7", 14,6, 2,0},        // 5
  {"\xc2\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a\x9a" // 6
    "\x9a\x9a\xc3", 10,7, 2,0},
  {"\x95", 10, 8, 2,0},{"                ", 11,8, 0,2},           // 7
  {"\x95", 27, 8, 2,0},
  {"\x95", 10, 9, 2,0},{"      REST      ", 11,9, 0,2},           // 8
  {"\x95", 27, 9, 2,0},
  {"\x95", 10,10, 2,0},{"       IN       ", 11,10, 0,2},          // 9
  {"\x95", 27,10, 2,0},
  {"\x95", 10,11, 2,0},{"     PEACE      ", 11,11, 0,2},          // 10
  {"\x95", 27,11, 2,0},
  {"\x95", 10,12, 2,0},{"                ", 11,12, 0,2},          // 11
  {"\x95", 27,12, 2,0},
  {"\x95", 10,13, 2,0},{"                ", 11,13, 0,2},          // 12
  {"\x95", 27,13, 2,0},
  {"\x95", 10,14, 2,0},{"   killed by a  ", 11,14, 0,2},          // 13
  {"\x95", 27,14, 2,0},
  {"\x95", 10,15, 2,0},{"                ", 11,15, 0,2},          // 14
  {"\x95", 27,15, 2,0},
  {"\x95", 10,16, 2,0},{"                ", 11,16, 0,2},          // 15
  {"\x95", 27,16, 2,0},
  {"\x95", 10,17, 2,0},{"   \xe2   \xe2    \xe2   ", 11,17, 3,2}, // 16
  {"\x95", 27,17, 2,0},
  {"\x95", 10,18, 2,0},{"                ", 11,18, 0,2},          // 17
  {"\x95", 27,18, 2,0},
  {"\x95", 10,19, 2,0},{"                ", 11,19, 0,2},          // 18
  {"\x95", 27,19, 2,0},
  {"\xd2\xd2\xc6\x5c\x5c/)\xc6\x5c\x5c/\xc6(\x5c/)\xc6(/\xc6"     // 19
    "\x5c\xc6)/\xc6\xd2\xd2", 6,20, 1,0},
};
//---------------------------------------------------------------------------
void display_permadeath()
{
  extern struct TEntity *player;
  u8 x = get_center (GRAVE_TEXT_STARTX, GRAVE_WIDTH, name(player));

  cpct_setPalette (perma_palette, 4);
  cls();

  display_text_lines (permadeath, NUM_PERMADEATH_VALUES);

  cpct_drawStringM1_f (name(player),
    cpct_getScreenPtr (CPCT_VMEM_START, x,HERO_TEXT_Y), 0,2);

  x = get_center (GRAVE_TEXT_STARTX, GRAVE_WIDTH, "snake");
  cpct_drawStringM1_f ("snake",
    cpct_getScreenPtr (CPCT_VMEM_START, x,KILLEDBY_TEXT_Y), 0,2);
}